
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	TOKEN	273
#define	NUMBER	274
#define	TYPETOKEN	275
#define	ARRAY_DIM	276
#define	SINGLE_CHAR	277
#define	CCODE	278
#define	HTCODE	279
#define	PHCODE	280
#define	HCODE	281
#define	ACODE	282
#define	ATCODE	283
#define	STRING	284
#define	PUBLIC	285
#define	PRIVATE	286
#define	PROTECTED	287
#define	CLASSWIDE	288
#define	PROPERTY	289
#define	ARGUMENT	290
#define	VIRTUAL	291
#define	SIGNAL	292
#define	OVERRIDE	293
#define	NICK	294
#define	BLURB	295
#define	MAXIMUM	296
#define	MINIMUM	297
#define	DEFAULT_VALUE	298
#define	FLAGS	299
#define	TYPE	300
#define	FLAGS_TYPE	301
#define	ENUM_TYPE	302
#define	PARAM_TYPE	303
#define	BOXED_TYPE	304
#define	OBJECT_TYPE	305

#line 22 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "treefuncs.h"
#include "main.h"
#include "util.h"

#define _(x) (x)
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static char *chunk_size = NULL;
static char *bonobo_x_class = NULL;
static GList *typestack = NULL;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;
static Method *last_added_method = NULL;

/* destructor and initializer for variables */
static gboolean destructor_unref = FALSE;
static char *destructor = NULL;
static int destructor_line = 0;
static gboolean destructor_simple = TRUE;
static char *initializer = NULL;
static int initializer_line = 0;

static char *onerror = NULL;
static char *defreturn = NULL;

static GList *gtktypes = NULL;

static Property *property = NULL;

/* this can be a global as we will only do one function at a time
   anyway */
static int the_scope = NO_SCOPE;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ", str, " at end of input", NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp, '\n')))
			*p='.';

		out=g_strconcat("Error: ", str, " before '", tmp, "'", NULL);
		g_free(tmp);
	}

	fprintf(stderr, "%s:%d: %s\n", filename, line_no, out);
	g_free(out);
	
	exit(1);
}

static Type *
pop_type(void)
{
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	return type;
}

static void
push_variable (char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = pop_type ();

	type->postfix = postfix;
	
	var = node_new (VARIABLE_NODE,
			"scope", scope,
			"vtype:steal", type,
			"id:steal", name,
			"line_no", line_no,
			"destructor_unref", destructor_unref,
			"destructor:steal", destructor,
			"destructor_line", destructor_line,
			"destructor_simple", destructor_simple,
			"initializer:steal", initializer,
			"initializer_line", initializer_line,
			NULL);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function (int scope, int method, char *oid, char *id,
	       GString *cbuf, int line_no, int ccode_line,
	       gboolean vararg, GList *flags)
{
	Node *node;
	Type *type;
	char *c_cbuf;

	g_assert(scope != CLASS_SCOPE);
       
	if(method == INIT_METHOD || method == CLASS_INIT_METHOD) {
		type = (Type *)node_new (TYPE_NODE,
					 "name", "void",
					 NULL);
	} else {
		type = pop_type();
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((method == SIGNAL_FIRST_METHOD ||
	    method == SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data, "NONE")==0)) {
		error_print(GOB_WARN, line_no,
			    _("The number of GTK arguments and "
			      "function arguments for a signal "
			      "don't seem to match"));
	}
	if(g_list_length(gtktypes) > 2) {
		GList *li;
		for(li = gtktypes->next; li; li = li->next) {
			if(strcmp(li->data, "NONE")==0) {
				error_print(GOB_ERROR, line_no,
					    _("NONE can only appear in an "
					      "argument list by itself"));
			}
		}
	}
	if(cbuf) {
		char *p;
		c_cbuf = p = cbuf->str;
		while(p && *p && (*p==' ' || *p=='\t' || *p=='\n' || *p=='\r'))
			p++;
		if(!p || !*p)
			c_cbuf = NULL;
	} else
		c_cbuf = NULL;

	node = node_new (METHOD_NODE,
			 "scope", scope,
			 "method", method,
			 "mtype:steal", type,
			 "otype:steal", oid,
			 "gtktypes:steal", gtktypes,
			 "flags:steal", flags,
			 "id:steal", id,
			 "args:steal", funcargs,
			 "onerror:steal", onerror,
			 "defreturn:steal", defreturn,
			 "cbuf:steal", c_cbuf,
			 "line_no", line_no,
			 "ccode_line", ccode_line,
			 "vararg", vararg,
			 "unique_id", method_unique_id++,
			 NULL);

	last_added_method = (Method *)node;

	if(cbuf)
		g_string_free(cbuf,
			      /*only free segment if we haven't passed it
				above */
			      c_cbuf?FALSE:TRUE);
	gtktypes = NULL;
	funcargs = NULL;

	onerror = NULL;
	defreturn = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
free_all_global_state(void)
{
	g_free(onerror);
	onerror = NULL;
	g_free(defreturn);
	defreturn = NULL;

	g_free(chunk_size);
	chunk_size = NULL;
	
	g_list_foreach(gtktypes, (GFunc)g_free, NULL);
	g_list_free(gtktypes);
	gtktypes = NULL;

	node_list_free (funcargs);
	funcargs = NULL;
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = pop_type();

	type->postfix = postfix;
	
	node = node_new (FUNCARG_NODE,
			 "atype:steal", type,
			 "name:steal", name,
			 "checks:steal", checks,
			 NULL);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = node_new (TYPE_NODE,
			 "name:steal", tn,
			 "pointer", "*",
			 NULL);
	node = node_new (FUNCARG_NODE,
			 "atype:steal", (Type *)type,
			 "name:steal", name,
			 NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id, gboolean constant)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = node_new (TYPE_NODE,
			 "name", ((Class *)class)->otype,
			 "pointer", constant ? "const *" : "*",
			 NULL);
	ch = g_list_append (ch, node_new (CHECK_NODE,
					  "chtype", NULL_CHECK,
					  NULL));
	ch = g_list_append (ch, node_new (CHECK_NODE,
					  "chtype", TYPE_CHECK,
					  NULL));
	node = node_new (FUNCARG_NODE,
			 "atype:steal", (Type *)type,
			 "name:steal", id,
			 "checks:steal", ch,
			 NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static Variable *
find_var_or_die(const char *id, int line)
{
	GList *li;

	for(li = class_nodes; li != NULL; li = li->next) {
		Variable *var;
		Node *node = li->data;
		if(node->type != VARIABLE_NODE)
			continue;
		var = li->data;
		if(strcmp(var->id, id)==0)
			return var;
	}

	error_printf(GOB_ERROR, line, _("Variable %s not defined here"), id);

	g_assert_not_reached();
	return NULL;
}

static gboolean
set_return_value(char *type, char *val)
{
	if(strcmp(type, "onerror")==0) {
		if(!onerror) {
			onerror = val;
			return TRUE;
		} else
			return FALSE;
	} else if(strcmp(type, "defreturn")==0) {
		if(!defreturn) {
			defreturn = val;
			return TRUE;
		} else
			return FALSE;
	}
	return FALSE;
}

static void
export_accessors (const char *var_name,
		  gboolean do_get,
		  gboolean do_set,
		  int get_lineno,
		  int set_lineno,
		  Type *type,
		  const char *gtktype,
		  int lineno)
{	
	Type *the_type;

	if (type != NULL)
		the_type = (Type *)node_copy ((Node *)type);
	else
		the_type = get_tree_type (gtktype, TRUE);

	if (the_type == NULL) {
		error_print (GOB_ERROR, line_no,
			     _("Cannot determine type of property or argument"));
		return;
	}

	if (do_get) {
		char *get_id = g_strdup_printf ("get_%s", var_name);
		GString *get_cbuf = g_string_new (NULL);
		Node *node1 = node_new (TYPE_NODE,
					"name", the_type->name,
					"pointer", the_type->pointer,
					"postfix", the_type->postfix,
					NULL);
		Node *node3 = node_new (TYPE_NODE,
					"name", class->class.otype,
					"pointer", "*",
					NULL);

		g_string_sprintf (get_cbuf,
				  "\t%s%s val; "
				  "g_object_get (G_OBJECT (self), \"%s\", "
				  "&val, NULL); "
				  "return val;\n",
				  the_type->name, 
				  the_type->pointer ? the_type->pointer : "",
				  var_name);
		
		typestack = g_list_prepend (typestack, node1);
		typestack = g_list_prepend (typestack, node3);
		
		push_funcarg ("self", FALSE);
		
		push_function (PUBLIC_SCOPE, REGULAR_METHOD, NULL,
			       get_id, get_cbuf, get_lineno,
			       lineno, FALSE, NULL);
	}
	
	if (do_set) {
		char *set_id = g_strdup_printf ("set_%s", var_name);
		GString *set_cbuf = g_string_new (NULL);
		Node *node1 = node_new (TYPE_NODE, 
					"name", the_type->name,
					"pointer", the_type->pointer,
					"postfix", the_type->postfix,
					NULL);
		Node *node2 = node_new (TYPE_NODE, 
					"name", "void",
					NULL);
		Node *node3 = node_new (TYPE_NODE, 
					"name", class->class.otype,
					"pointer", "*",
					NULL);

		g_string_sprintf (set_cbuf,
				  "\tg_object_set (G_OBJECT (self), "
				  "\"%s\", val, NULL);\n",
				  var_name);

		typestack = g_list_prepend (typestack, node2);
		typestack = g_list_prepend (typestack, node1);
		typestack = g_list_prepend (typestack, node3);
		
		push_funcarg ("self", FALSE);
		push_funcarg ("val", FALSE);
	
		typestack = g_list_prepend (typestack, node2);
		push_function (PUBLIC_SCOPE, REGULAR_METHOD, NULL,
			       set_id, set_cbuf, set_lineno,
			       lineno, FALSE, NULL);
	}

	node_free ((Node *)the_type);
}

static void
property_link_and_export (Node *node)
{
	Property *prop = (Property *)node;

	if (prop->link) {
		const char *root;
		char *get = NULL, *set = NULL;
		Variable *var;

		if (prop->set != NULL ||
		    prop->get != NULL) {	
			error_print (GOB_ERROR, prop->line_no,
				     _("Property linking requested, but "
				       "getters and setters exist"));
		}

		var = find_var_or_die (prop->name, prop->line_no);
		if(var->scope == PRIVATE_SCOPE) {
			root = "self->_priv";
		} else if (var->scope == CLASS_SCOPE) {
			root = "SELF_GET_CLASS(self)";
			if (no_self_alias)
				error_print (GOB_ERROR, prop->line_no,
					     _("Self aliases needed when autolinking to a classwide member"));
		} else {
			root = "self";
		}

		if (strcmp (prop->gtktype, "STRING") == 0) {
			set = g_strdup_printf("g_free (%s->%s); "
					      "%s->%s = g_value_dup_string (VAL);",
					      root, prop->name,
					      root, prop->name);
			get = g_strdup_printf("g_value_set_string (VAL, %s->%s);",
					      root, prop->name);
		} else if (strcmp (prop->gtktype, "OBJECT") == 0) {
			set = g_strdup_printf("{ GtkObject *___old = (GtkObject *)%s->%s; "
					      "GtkObject *___new = (GtkObject *)gtk_value_get_object (VAL); "
					      "if (___new != NULL) { "
					        "gtk_object_ref (GTK_OBJECT (___new)); "
					        "%s->%s = GTK_OBJECT (___new); "
					      "} else { "
					        "%s->%s = NULL; "
					      "} "
					      "if (___old != NULL) { "
					        "gtk_object_unref (GTK_OBJECT (___old)); "
					      "} "
					      "}",
					      root, prop->name,
					      root, prop->name,
					      root, prop->name);
			get = g_strdup_printf("g_value_set_object (VAL, %s->%s);",
					      root, prop->name);
		} else if (strcmp (prop->gtktype, "BOXED") == 0) {
			if (prop->extra_gtktype == NULL) {
				error_print (GOB_ERROR, prop->line_no,
					     _("Property linking requested for BOXED, but "
					       "boxed_type not set"));
			}
			set = g_strdup_printf("{ gpointer ___old = (gpointer)%s->%s; "
					      "gpointer ___new = (gpointer)gtk_value_get_boxed (VAL); "
					      "if (___new != ___old) { "
					        "if (___old != NULL) g_boxed_free (%s, ___old); "
					        "if (___new != NULL) %s->%s = g_boxed_copy (%s, ___new); "
					        "else %s->%s = NULL;"
					      "} "
					      "}",
					      root, prop->name,
					      prop->extra_gtktype,
					      root, prop->name,
					      prop->extra_gtktype,
					      root, prop->name);
			get = g_strdup_printf("g_value_set_object (VAL, %s->%s);",
					      root, prop->name);
		} else {
			char *set_func;
			char *get_func;
			set_func = g_strdup_printf ("g_value_set_%s", prop->gtktype);
			g_strdown (set_func);
			get_func = g_strdup_printf ("g_value_get_%s", prop->gtktype);
			g_strdown (get_func);

			set = g_strdup_printf("%s->%s = %s (VAL);",
					      root, prop->name,
					      get_func);
			get = g_strdup_printf("%s (VAL, %s->%s);",
					      set_func,
					      root, prop->name);

			g_free (get_func);
			g_free (set_func);
		}

		node_set (node,
			  "get:steal", get,
			  "get_line", prop->line_no,
			  "set:steal", set,
			  "set_line", prop->line_no,
			  NULL);
	}

	if (prop->export) {
		export_accessors (prop->name,
				  prop->get != NULL, prop->get_line,
				  prop->set != NULL,  prop->get_line,
				  prop->ptype,
				  prop->gtktype,
				  prop->line_no);
	} 
}


static char *
debool (char *s)
{
	if (strcmp (s, "BOOL") == 0) {
		error_print (GOB_WARN, line_no,
			    _("BOOL type is deprecated, please use BOOLEAN"));
		g_free (s);
		return g_strdup ("BOOLEAN");
	} else {
		return s;
	}
}

static void
ensure_property (void)
{
	if (property == NULL)
		property = (Property *)node_new (PROPERTY_NODE, NULL);
}


#line 570 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		340
#define	YYFLAG		-32768
#define	YYNTBASE	65

#define YYTRANSLATE(x) ((unsigned)(x) <= 305 ? yytranslate[x] : 110)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    63,     2,     2,     2,     2,     2,     2,    54,
    55,    60,     2,    58,    64,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    56,    62,
    57,    61,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    52,    59,    53,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    14,    16,    18,    20,    22,
    24,    27,    29,    34,    38,    44,    45,    51,    57,    60,
    62,    64,    67,    69,    71,    73,    75,    77,    79,    81,
    83,    86,    90,    93,    97,   100,   103,   105,   107,   108,
   114,   121,   134,   144,   151,   155,   156,   168,   177,   183,
   187,   188,   192,   194,   196,   201,   203,   205,   209,   213,
   217,   221,   225,   229,   233,   237,   241,   245,   249,   253,
   255,   261,   263,   267,   268,   272,   274,   277,   279,   281,
   283,   286,   289,   292,   296,   300,   303,   306,   309,   311,
   314,   316,   319,   321,   323,   325,   327,   329,   331,   333,
   335,   337,   339,   341,   343,   345,   348,   351,   355,   358,
   360,   364,   368,   371,   373,   378,   382,   384,   387,   389,
   400,   412,   422,   432,   441,   453,   462,   468,   471,   476,
   477,   479,   482,   484,   486,   489,   492,   496,   501,   506,
   508,   512,   514,   518,   520,   523,   527,   534,   542,   545,
   547,   549,   552,   555,   559,   563,   567,   571,   573,   576,
   578
};

static const short yyrhs[] = {    67,
    68,    67,     0,    68,    67,     0,    67,    68,     0,    68,
     0,    24,     0,    27,     0,    25,     0,    26,     0,    28,
     0,    29,     0,    67,    66,     0,    66,     0,    69,    52,
    71,    53,     0,    69,    52,    53,     0,     3,    21,     4,
    21,    70,     0,     0,    54,    19,    19,    55,    70,     0,
    54,    19,    20,    55,    70,     0,    71,    72,     0,    72,
     0,   100,     0,    19,   100,     0,    77,     0,    78,     0,
    80,     0,    56,     0,    31,     0,    32,     0,    33,     0,
    34,     0,    19,    19,     0,    19,    52,    24,     0,    57,
   109,     0,    57,    52,    24,     0,    74,    75,     0,    75,
    74,     0,    75,     0,    74,     0,     0,    73,    89,    19,
    76,    56,     0,    73,    89,    19,    22,    76,    56,     0,
    36,    87,    86,    19,    79,    19,    52,    24,    19,    52,
    24,    56,     0,    36,    87,    86,    19,    79,    19,    52,
    24,    56,     0,    36,    87,    86,    19,    79,    19,     0,
    54,    19,    55,     0,     0,    35,    19,    19,    81,    19,
    52,    24,    19,    52,    24,    56,     0,    35,    19,    19,
    81,    19,    52,    24,    56,     0,    35,    19,    19,    81,
    56,     0,    54,    82,    55,     0,     0,    82,    58,    85,
     0,    85,     0,    30,     0,    19,    54,    30,    55,     0,
   109,     0,    83,     0,    40,    57,    83,     0,    41,    57,
    83,     0,    42,    57,   109,     0,    43,    57,   109,     0,
    44,    57,    84,     0,    45,    57,    88,     0,    46,    57,
    89,     0,    47,    57,    19,     0,    48,    57,    19,     0,
    49,    57,    19,     0,    50,    57,    19,     0,    51,    57,
    19,     0,    19,     0,    19,    54,    19,    89,    55,     0,
    19,     0,    54,    88,    55,     0,     0,    19,    59,    88,
     0,    19,     0,    90,    94,     0,    90,     0,    91,     0,
    19,     0,     5,    19,     0,    19,     5,     0,    93,    19,
     0,     5,    93,    19,     0,    93,    19,     5,     0,    92,
    91,     0,    21,    91,     0,     5,    91,     0,    21,     0,
    21,     5,     0,    92,     0,    92,     5,     0,     6,     0,
    18,     0,    14,     0,    15,     0,    13,     0,    16,     0,
    17,     0,    11,     0,    12,     0,     7,     0,     8,     0,
     9,     0,    60,     0,    60,     5,     0,    60,    94,     0,
    60,     5,    94,     0,    19,    97,     0,    97,     0,    73,
    19,    97,     0,    19,    73,    97,     0,    73,    97,     0,
    95,     0,    19,    54,    98,    55,     0,    98,    58,    19,
     0,    19,     0,    52,    24,     0,    56,     0,    38,    87,
    96,    89,    19,    54,   103,    55,   101,    99,     0,    73,
    38,    87,    95,    89,    19,    54,   103,    55,   101,    99,
     0,    37,    73,    89,    19,    54,   103,    55,   101,    99,
     0,    73,    37,    89,    19,    54,   103,    55,   101,    99,
     0,    37,    89,    19,    54,   103,    55,   101,    99,     0,
    39,    54,    21,    55,    89,    19,    54,   103,    55,   101,
    99,     0,    73,    89,    19,    54,   103,    55,   101,    99,
     0,    19,    54,    19,    55,    99,     0,    19,   102,     0,
    19,   102,    19,   102,     0,     0,   109,     0,    52,    24,
     0,     6,     0,    19,     0,    19,     5,     0,     5,    19,
     0,    19,    58,   104,     0,    19,     5,    58,   104,     0,
     5,    19,    58,   104,     0,   104,     0,   105,    58,    10,
     0,   105,     0,   105,    58,   106,     0,   106,     0,    89,
    19,     0,    89,    19,    22,     0,    89,    19,    54,    19,
   107,    55,     0,    89,    19,    22,    54,    19,   107,    55,
     0,   107,   108,     0,   108,     0,    19,     0,    61,   109,
     0,    62,   109,     0,    61,    57,   109,     0,    62,    57,
   109,     0,    57,    57,   109,     0,    63,    57,   109,     0,
    20,     0,    64,    20,     0,    23,     0,    19,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   591,   592,   593,   594,   597,   606,   615,   624,   633,   642,
   653,   654,   657,   662,   669,   679,   680,   692,   706,   707,
   710,   711,   719,   720,   721,   722,   725,   726,   727,   728,
   731,   751,   775,   779,   787,   788,   789,   790,   791,   797,
   800,   805,   873,   927,  1015,  1023,  1028,  1076,  1112,  1128,
  1129,  1132,  1133,  1136,  1137,  1149,  1150,  1153,  1159,  1165,
  1171,  1177,  1183,  1189,  1196,  1202,  1208,  1214,  1220,  1226,
  1246,  1255,  1261,  1262,  1265,  1268,  1274,  1281,  1290,  1293,
  1296,  1300,  1304,  1308,  1313,  1321,  1325,  1330,  1334,  1337,
  1341,  1344,  1349,  1350,  1351,  1352,  1353,  1354,  1355,  1356,
  1357,  1360,  1361,  1362,  1365,  1366,  1367,  1371,  1378,  1390,
  1396,  1408,  1420,  1423,  1429,  1434,  1437,  1442,  1443,  1447,
  1463,  1479,  1495,  1511,  1522,  1528,  1538,  1561,  1572,  1591,
  1597,  1598,  1604,  1605,  1616,  1627,  1638,  1648,  1658,  1668,
  1671,  1672,  1675,  1676,  1679,  1682,  1685,  1693,  1703,  1704,
  1707,  1724,  1731,  1738,  1745,  1752,  1759,  1768,  1769,  1773,
  1774
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","TOKEN","NUMBER","TYPETOKEN","ARRAY_DIM",
"SINGLE_CHAR","CCODE","HTCODE","PHCODE","HCODE","ACODE","ATCODE","STRING","PUBLIC",
"PRIVATE","PROTECTED","CLASSWIDE","PROPERTY","ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE",
"NICK","BLURB","MAXIMUM","MINIMUM","DEFAULT_VALUE","FLAGS","TYPE","FLAGS_TYPE",
"ENUM_TYPE","PARAM_TYPE","BOXED_TYPE","OBJECT_TYPE","'{'","'}'","'('","')'",
"';'","'='","','","'|'","'*'","'>'","'<'","'!'","'-'","prog","ccode","ccodes",
"class","classdec","classflags","classcode","thing","scope","destructor","initializer",
"varoptions","variable","argument","export","property","param_spec","param_spec_list",
"string","anyval","param_spec_value","argtype","flags","flaglist","type","specifier_list",
"spec_list","specifier","strunionenum","pointer","simplesigtype","fullsigtype",
"sigtype","tokenlist","codenocode","method","returnvals","retcode","funcargs",
"arglist","arglist1","arg","checklist","check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    65,    65,    65,    65,    66,    66,    66,    66,    66,    66,
    67,    67,    68,    68,    69,    70,    70,    70,    71,    71,
    72,    72,    72,    72,    72,    72,    73,    73,    73,    73,
    74,    74,    75,    75,    76,    76,    76,    76,    76,    77,
    77,    78,    78,    78,    79,    79,    80,    80,    80,    81,
    81,    82,    82,    83,    83,    84,    84,    85,    85,    85,
    85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
    86,    86,    87,    87,    88,    88,    89,    89,    90,    90,
    90,    90,    90,    90,    90,    91,    91,    91,    91,    91,
    91,    91,    92,    92,    92,    92,    92,    92,    92,    92,
    92,    93,    93,    93,    94,    94,    94,    94,    95,    95,
    96,    96,    96,    96,    97,    98,    98,    99,    99,   100,
   100,   100,   100,   100,   100,   100,   100,   101,   101,   101,
   102,   102,   103,   103,   103,   103,   103,   103,   103,   103,
   104,   104,   105,   105,   106,   106,   106,   106,   107,   107,
   108,   108,   108,   108,   108,   108,   108,   109,   109,   109,
   109
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     2,     1,     4,     3,     5,     0,     5,     5,     2,     1,
     1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     3,     2,     3,     2,     2,     1,     1,     0,     5,
     6,    12,     9,     6,     3,     0,    11,     8,     5,     3,
     0,     3,     1,     1,     4,     1,     1,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
     5,     1,     3,     0,     3,     1,     2,     1,     1,     1,
     2,     2,     2,     3,     3,     2,     2,     2,     1,     2,
     1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     2,     2,     3,     2,     1,
     3,     3,     2,     1,     4,     3,     1,     2,     1,    10,
    11,     9,     9,     8,    11,     8,     5,     2,     4,     0,
     1,     2,     1,     1,     2,     2,     3,     4,     4,     1,
     3,     1,     3,     1,     2,     3,     6,     7,     2,     1,
     1,     2,     2,     3,     3,     3,     3,     1,     2,     1,
     1
};

static const short yydefact[] = {     0,
     0,     5,     7,     8,     6,     9,    10,    12,     0,     4,
     0,     0,    11,     3,     2,     0,     0,     1,     0,    27,
    28,    29,    30,     0,    74,     0,    74,     0,    14,    26,
     0,    20,     0,    23,    24,    25,    21,    16,     0,     0,
     0,    22,     0,     0,     0,     0,    93,   102,   103,   104,
   100,   101,    97,    95,    96,    98,    99,    94,    80,    89,
     0,     0,    78,    79,    91,     0,     0,     0,    13,    19,
     0,    74,     0,     0,    15,     0,     0,    51,    76,     0,
    72,     0,     0,    81,    88,     0,    82,    90,    87,     0,
     0,   105,    77,    92,    86,    83,     0,     0,   114,     0,
   110,     0,     0,     0,    39,     0,     0,     0,     0,     0,
     0,    73,     0,    46,    84,     0,     0,   106,   107,    85,
     0,     0,     0,   109,     0,   113,     0,     0,     0,     0,
     0,     0,    39,     0,     0,    38,    37,     0,     0,     0,
     0,   119,   127,    70,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    53,     0,    49,
    75,     0,     0,     0,     0,     0,    93,    80,     0,     0,
   140,   142,   144,   108,   117,     0,   112,   111,     0,     0,
     0,     0,    31,     0,     0,     0,   161,   158,   160,     0,
     0,    33,    35,    36,    40,    16,    16,   118,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    50,     0,     0,     0,     0,    44,     0,    81,    82,     0,
   145,   130,     0,   115,     0,     0,     0,     0,     0,    32,
    41,   130,    34,   159,    17,    18,     0,    54,    58,    59,
    60,    61,   161,    57,    62,    56,    63,    64,    65,    66,
    67,    68,    69,    52,     0,    71,    45,     0,   130,     0,
     0,   137,   146,     0,     0,     0,   141,   143,   116,     0,
     0,   130,     0,     0,     0,     0,    48,     0,     0,   139,
   138,     0,     0,     0,   128,   131,   124,   130,     0,     0,
     0,   126,     0,     0,     0,    43,   122,     0,   151,     0,
     0,     0,     0,     0,   150,   132,     0,     0,   130,   123,
   130,    55,     0,     0,     0,     0,     0,   152,     0,   153,
     0,   147,   149,   129,   120,     0,     0,    47,     0,   148,
   156,   154,   155,   157,   125,   121,    42,     0,     0,     0
};

static const short yydefgoto[] = {   338,
     8,     9,    10,    11,    75,    31,    32,    33,   136,   137,
   138,    34,    35,   164,    36,   110,   157,   239,   245,   158,
    82,    45,    80,   169,    63,    64,    65,    66,    93,    99,
   100,   101,   176,   143,    37,   266,   285,   170,   171,   172,
   173,   304,   305,   286
};

static const short yypact[] = {   144,
    -7,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   144,   407,
   -21,    40,-32768,   407,   407,   121,    71,   407,   166,-32768,
-32768,-32768,-32768,    78,    45,   266,    45,    54,-32768,-32768,
   156,-32768,   216,-32768,-32768,-32768,-32768,    92,    94,    97,
   216,-32768,   157,   159,   160,   313,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   158,   381,
   330,   164,   136,-32768,   395,   183,   257,   185,-32768,-32768,
   330,    45,   200,   207,-32768,   184,   221,   187,   188,   189,
   192,   223,   409,-32768,-32768,   229,-32768,   409,-32768,   230,
   197,     1,-32768,   409,-32768,   247,   182,   236,-32768,   330,
-32768,   201,   238,   239,    68,    10,    61,   232,   219,    22,
   159,-32768,   273,   240,-32768,   241,   347,   136,-32768,-32768,
   242,   274,   297,-32768,    -4,-32768,   304,   330,   279,    -4,
   330,    60,    -9,   347,     0,   283,   331,   301,   312,   319,
   360,-32768,-32768,-32768,   332,   333,   334,   346,   348,   361,
   362,   371,   372,   380,   382,   383,   106,-32768,   336,-32768,
-32768,   330,   385,   398,   347,   364,   386,     7,   419,   387,
-32768,   388,-32768,-32768,-32768,   107,-32768,-32768,   389,   425,
   347,   426,-32768,   423,   392,   394,-32768,-32768,-32768,   427,
   430,-32768,-32768,-32768,-32768,    92,    92,-32768,    13,    13,
    37,    37,     5,   159,   330,   433,   434,   435,   436,   437,
-32768,   219,   438,   402,   403,   408,   404,   152,   153,   330,
    66,   442,   296,-32768,   444,   347,   410,   411,   413,-32768,
-32768,   442,-32768,-32768,-32768,-32768,   414,-32768,-32768,-32768,
-32768,-32768,   414,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    39,-32768,-32768,   441,   442,   330,
   330,-32768,   415,   451,    19,    61,-32768,-32768,-32768,   416,
   347,   442,   347,    61,   443,   420,-32768,    53,    61,-32768,
-32768,   455,    88,   452,   456,-32768,-32768,   442,   422,    61,
   424,-32768,   428,   454,   429,-32768,-32768,    88,-32768,   431,
    57,    62,   432,    72,-32768,-32768,    19,    61,   442,-32768,
   442,-32768,   439,   458,    81,    37,    37,-32768,    37,-32768,
    37,-32768,-32768,-32768,-32768,    61,    61,-32768,   440,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   480,   484,-32768
};

static const short yypgoto[] = {-32768,
    87,   118,   476,-32768,   -66,-32768,   459,    -8,   349,   351,
   358,-32768,-32768,-32768,-32768,-32768,-32768,   -85,-32768,   280,
-32768,   -18,  -106,   -25,-32768,   -43,-32768,   -42,   -65,   390,
-32768,   120,-32768,  -253,   474,  -225,   190,  -132,  -150,-32768,
   275,   202,  -211,  -135
};


#define	YYLAST		500


static const short yytable[] = {   192,
    62,   186,    85,    86,   161,   118,   274,    73,    67,   132,
    41,   219,   287,    12,   121,    77,    89,    61,   187,   188,
   292,    95,   189,   243,   188,   297,   119,   189,   139,   140,
    16,   237,   217,   279,   238,    90,   310,   187,   188,    85,
   159,   189,   238,    17,    85,   103,   290,   135,   228,   122,
    85,   190,   174,   104,   325,   187,   188,   276,    98,   189,
    92,  -134,   308,   191,   220,   241,   242,   246,   191,   262,
   284,   295,   335,   336,   127,   187,   188,   160,   183,   189,
   187,   188,   191,   326,   189,   327,   132,   263,   123,   133,
   299,    38,   323,   270,   277,    13,    43,   247,    44,   299,
   191,    13,   180,   323,    13,   182,   299,    68,   296,   280,
   281,   184,   141,   317,   240,    76,   142,   244,   319,   264,
   191,   134,    85,    86,   135,   191,   322,    15,   300,   235,
   236,    18,   301,   302,   303,   330,   214,   300,   289,    19,
   291,   301,   302,   303,   300,    74,     1,    40,   301,   302,
   303,    20,    21,    22,    23,    24,    25,    26,    27,    28,
   211,   224,    87,   212,   225,   318,   320,     2,     3,     4,
     5,     6,     7,    29,    19,    78,    30,    79,    81,   248,
   331,   332,    91,   333,    39,   334,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    92,    20,    21,    22,    23,
   121,    96,    26,    27,    28,   102,  -136,  -135,    69,   260,
   261,    30,    20,    21,    22,    23,   124,   126,   105,    40,
    46,    47,    48,    49,    50,   106,    51,    52,    53,    54,
    55,    56,    57,    58,    59,   122,    60,   144,   107,   108,
   109,   114,   177,   112,   178,   113,   111,   115,   116,   124,
   117,   120,    71,    72,   125,   128,   129,   130,   145,   146,
   147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
    46,    47,    48,    49,    50,    97,    51,    52,    53,    54,
    55,    56,    57,    58,    59,   134,    60,    20,    21,    22,
    23,   162,   175,   163,   165,   122,    20,    21,    22,    23,
    46,    47,    48,    49,    50,   267,    51,    52,    53,    54,
    55,    56,    57,    58,    59,   121,    60,    83,    47,    48,
    49,    50,   179,    51,    52,    53,    54,    55,    56,    57,
    58,    84,   181,    60,    46,    47,    48,    49,    50,   135,
    51,    52,    53,    54,    55,    56,    57,    58,    59,   132,
    60,   166,   167,    48,    49,    50,   195,    51,    52,    53,
    54,    55,    56,    57,    58,   168,   196,    60,    83,    47,
    48,    49,    50,   197,    51,    52,    53,    54,    55,    56,
    57,    58,   218,   198,    60,    88,    47,   213,   199,   200,
   201,    51,    52,    53,    54,    55,    56,    57,    58,    94,
    47,    60,   202,   215,   203,    51,    52,    53,    54,    55,
    56,    57,    58,    83,    47,    60,   216,   204,   205,    51,
    52,    53,    54,    55,    56,    57,    58,   206,   207,    60,
     2,     3,     4,     5,     6,     7,   208,   221,   209,   210,
  -133,   222,   226,   227,   229,   223,   230,   231,   232,   234,
   233,   249,   250,   251,   252,   253,   256,   257,   259,   258,
   265,   255,   269,   271,   278,   272,   273,   275,   282,   283,
   288,   294,   293,   298,   307,   306,   309,   313,   311,   339,
   314,   329,   312,   340,    14,   194,   193,   316,   321,    70,
   185,   254,    42,   131,   328,   337,   324,   268,     0,   315
};

static const short yycheck[] = {   135,
    26,   134,    46,    46,   111,     5,   232,    33,    27,    19,
    19,     5,   266,    21,    19,    41,    60,    26,    19,    20,
   274,    65,    23,    19,    20,   279,    92,    23,    19,    20,
    52,    19,   165,   259,    30,    61,   290,    19,    20,    83,
    19,    23,    30,     4,    88,    71,   272,    57,   181,    54,
    94,    52,   118,    72,   308,    19,    20,    19,    67,    23,
    60,    55,   288,    64,    58,   201,   202,   203,    64,   220,
    52,    19,   326,   327,   100,    19,    20,    56,    19,    23,
    19,    20,    64,   309,    23,   311,    19,    22,    97,    22,
    19,    21,   304,   226,    56,     9,    19,   204,    54,    19,
    64,    15,   128,   315,    18,   131,    19,    54,    56,   260,
   261,    52,    52,    57,   200,    19,    56,   203,    57,    54,
    64,    54,   166,   166,    57,    64,    55,    10,    57,   196,
   197,    14,    61,    62,    63,    55,   162,    57,   271,    19,
   273,    61,    62,    63,    57,    54,     3,    54,    61,    62,
    63,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    55,    55,     5,    58,    58,   301,   302,    24,    25,    26,
    27,    28,    29,    53,    19,    19,    56,    19,    19,   205,
   316,   317,    19,   319,    19,   321,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    60,    31,    32,    33,    34,
    19,    19,    37,    38,    39,    21,    55,    55,    53,    58,
    58,    56,    31,    32,    33,    34,    97,    98,    19,    54,
     5,     6,     7,     8,     9,    19,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    54,    21,    19,    55,    19,
    54,    19,   123,    55,   125,    54,    59,    19,    19,   130,
    54,     5,    37,    38,    19,    55,    19,    19,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
     5,     6,     7,     8,     9,    19,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    54,    21,    31,    32,    33,
    34,    19,    19,    54,    54,    54,    31,    32,    33,    34,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    19,    21,     5,     6,     7,
     8,     9,    19,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    54,    21,     5,     6,     7,     8,     9,    57,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    19,
    21,     5,     6,     7,     8,     9,    56,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    55,    21,     5,     6,
     7,     8,     9,    55,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    24,    21,     5,     6,    52,    57,    57,
    57,    11,    12,    13,    14,    15,    16,    17,    18,     5,
     6,    21,    57,    19,    57,    11,    12,    13,    14,    15,
    16,    17,    18,     5,     6,    21,    19,    57,    57,    11,
    12,    13,    14,    15,    16,    17,    18,    57,    57,    21,
    24,    25,    26,    27,    28,    29,    57,    19,    57,    57,
    55,    55,    54,    19,    19,    58,    24,    56,    55,    20,
    24,    19,    19,    19,    19,    19,    55,    55,    55,    52,
    19,    24,    19,    54,    24,    55,    54,    54,    54,    19,
    55,    52,    30,    19,    19,    24,    55,    24,    55,     0,
    52,    24,    55,     0,     9,   137,   136,    57,    57,    31,
   133,   212,    19,   104,    56,    56,   307,   223,    -1,   298
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 591 "parse.y"
{ ; ;
    break;}
case 2:
#line 592 "parse.y"
{ ; ;
    break;}
case 3:
#line 593 "parse.y"
{ ; ;
    break;}
case 4:
#line 594 "parse.y"
{ ; ;
    break;}
case 5:
#line 597 "parse.y"
{
			Node *node = node_new (CCODE_NODE,
					       "cctype", C_CCODE,
					       "cbuf:steal", (yyvsp[0].cbuf)->str,
					       "line_no", ccode_line,
					       NULL);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 6:
#line 606 "parse.y"
{
			Node *node = node_new (CCODE_NODE,
					       "cctype", H_CCODE,
					       "cbuf:steal", (yyvsp[0].cbuf)->str,
					       "line_no", ccode_line,
					       NULL);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 7:
#line 615 "parse.y"
{
			Node *node = node_new (CCODE_NODE,
					       "cctype", HT_CCODE,
					       "cbuf:steal", (yyvsp[0].cbuf)->str,
					       "line_no", ccode_line,
					       NULL);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 8:
#line 624 "parse.y"
{
			Node *node = node_new (CCODE_NODE,
					       "cctype", PH_CCODE,
					       "cbuf:steal", (yyvsp[0].cbuf)->str,
					       "line_no", ccode_line,
					       NULL);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 9:
#line 633 "parse.y"
{
			Node *node = node_new (CCODE_NODE,
					       "cctype", A_CCODE,
					       "cbuf:steal", (yyvsp[0].cbuf)->str,
					       "line_no", ccode_line,
					       NULL);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 10:
#line 642 "parse.y"
{
			Node *node = node_new (CCODE_NODE,
					       "cctype", AT_CCODE,
					       "cbuf:steal", (yyvsp[0].cbuf)->str,
					       "line_no", ccode_line,
					       NULL);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 11:
#line 653 "parse.y"
{ ; ;
    break;}
case 12:
#line 654 "parse.y"
{ ; ;
    break;}
case 13:
#line 657 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 14:
#line 662 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 15:
#line 669 "parse.y"
{
			class = node_new (CLASS_NODE,
					  "otype:steal", yyvsp[-3].id,
					  "ptype:steal", yyvsp[-1].id,
					  "bonobo_x_class:steal", bonobo_x_class,
					  "chunk_size:steal", chunk_size,
					  NULL);
						;
    break;}
case 17:
#line 680 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"chunks") == 0) {
				g_free (chunk_size);
				chunk_size = g_strdup(yyvsp[-2].id);
			} else if(strcmp(yyvsp[-3].id,"BonoboX") == 0) {
				g_free (bonobo_x_class);
				bonobo_x_class = g_strdup(yyvsp[-2].id);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
		;
    break;}
case 18:
#line 692 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"chunks") == 0) {
				g_free (chunk_size);
				if(atoi(yyvsp[-2].id) != 0)
					chunk_size = g_strdup(yyvsp[-2].id);
				else
					chunk_size = NULL;
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
		;
    break;}
case 19:
#line 706 "parse.y"
{ ; ;
    break;}
case 20:
#line 707 "parse.y"
{ ; ;
    break;}
case 21:
#line 710 "parse.y"
{ ; ;
    break;}
case 22:
#line 711 "parse.y"
{
			if (strcmp (yyvsp[-1].id, "BonoboX") != 0) {
				g_free(yyvsp[-1].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			last_added_method->bonobo_x_func = TRUE;
						;
    break;}
case 23:
#line 719 "parse.y"
{ ; ;
    break;}
case 24:
#line 720 "parse.y"
{ ; ;
    break;}
case 25:
#line 721 "parse.y"
{ ; ;
    break;}
case 26:
#line 722 "parse.y"
{ ; ;
    break;}
case 27:
#line 725 "parse.y"
{ the_scope = PUBLIC_SCOPE; ;
    break;}
case 28:
#line 726 "parse.y"
{ the_scope = PRIVATE_SCOPE; ;
    break;}
case 29:
#line 727 "parse.y"
{ the_scope = PROTECTED_SCOPE; ;
    break;}
case 30:
#line 728 "parse.y"
{ the_scope = CLASS_SCOPE; ;
    break;}
case 31:
#line 731 "parse.y"
{
			if (strcmp (yyvsp[-1].id, "destroywith") == 0) {
				g_free (yyvsp[-1].id);
				destructor_unref = FALSE;
				destructor = yyvsp[0].id;
				destructor_line = line_no;
				destructor_simple = TRUE;
			} else if (strcmp (yyvsp[-1].id, "unrefwith") == 0) {
				g_free (yyvsp[-1].id);
				destructor_unref = TRUE;
				destructor = yyvsp[0].id;
				destructor_line = line_no;
				destructor_simple = TRUE;
			} else {
				g_free (yyvsp[-1].id);
				g_free (yyvsp[0].id);
				yyerror (_("parse error"));
				YYERROR;
			}
				;
    break;}
case 32:
#line 751 "parse.y"
{
			if (strcmp (yyvsp[-2].id, "destroy") == 0) {
				g_free(yyvsp[-2].id);
				destructor_unref = FALSE;
				destructor = (yyvsp[0].cbuf)->str;
				g_string_free(yyvsp[0].cbuf, FALSE);
				destructor_line = ccode_line;
				destructor_simple = FALSE;
			} else if (strcmp (yyvsp[-2].id, "unref") == 0) {
				g_free (yyvsp[-2].id);
				destructor_unref = TRUE;
				destructor = (yyvsp[0].cbuf)->str;
				g_string_free (yyvsp[0].cbuf, FALSE);
				destructor_line = ccode_line;
				destructor_simple = FALSE;
			} else {
				g_free (yyvsp[-2].id);
				g_string_free (yyvsp[0].cbuf, TRUE);
				yyerror (_("parse error"));
				YYERROR;
			}
					;
    break;}
case 33:
#line 775 "parse.y"
{
			initializer = yyvsp[0].id;
			initializer_line = ccode_line;
				;
    break;}
case 34:
#line 779 "parse.y"
{
			initializer = (yyvsp[0].cbuf)->str;
			initializer_line = ccode_line;
			g_string_free(yyvsp[0].cbuf, FALSE);
				;
    break;}
case 35:
#line 787 "parse.y"
{ ; ;
    break;}
case 36:
#line 788 "parse.y"
{ ; ;
    break;}
case 37:
#line 789 "parse.y"
{ destructor = NULL; ;
    break;}
case 38:
#line 790 "parse.y"
{ initializer = NULL; ;
    break;}
case 39:
#line 791 "parse.y"
{
			destructor = NULL;
			initializer = NULL;
					;
    break;}
case 40:
#line 797 "parse.y"
{
			push_variable(yyvsp[-2].id, the_scope,yyvsp[-4].line, NULL);
						;
    break;}
case 41:
#line 800 "parse.y"
{
			push_variable(yyvsp[-3].id, the_scope, yyvsp[-5].line, yyvsp[-2].id);
						;
    break;}
case 42:
#line 805 "parse.y"
{
			Node *node = NULL;
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Type *type = pop_type();
				g_free (yyvsp[-6].id); 
				g_free (yyvsp[-3].id);
				node = node_new (ARGUMENT_NODE,
						 "gtktype:steal", yyvsp[-9].id,
						 "atype:steal", type,
						 "flags:steal", yyvsp[-10].list,
						 "name:steal", yyvsp[-8].id,
						 "get:steal", (yyvsp[-4].cbuf)->str,
						 "get_line", yyvsp[-5].line,
						 "set:steal", (yyvsp[-1].cbuf)->str,
						 "set_line", yyvsp[-2].line,
						 "line_no", yyvsp[-11].line,
						 NULL);

				class_nodes = g_list_append(class_nodes,node);

				g_string_free (yyvsp[-4].cbuf, FALSE);
				g_string_free (yyvsp[-1].cbuf, FALSE);

			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Type *type = pop_type();
				g_free (yyvsp[-6].id); 
				g_free (yyvsp[-3].id);
				node = node_new (ARGUMENT_NODE,
						 "gtktype:steal", yyvsp[-9].id,
						 "atype:steal", type,
						 "flags:steal", yyvsp[-10].list,
						 "name:steal", yyvsp[-8].id,
						 "get:steal", (yyvsp[-1].cbuf)->str,
						 "get_line", yyvsp[-2].line,
						 "set:steal", (yyvsp[-4].cbuf)->str,
						 "set_line", yyvsp[-5].line,
						 "line_no", yyvsp[-11].line,
						 NULL);
				g_string_free (yyvsp[-1].cbuf, FALSE);
				g_string_free (yyvsp[-4].cbuf, FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free (yyvsp[-9].id); 
				g_free (yyvsp[-8].id);
				g_free (yyvsp[-6].id); 
				g_free (yyvsp[-3].id);
				g_list_foreach (yyvsp[-10].list, (GFunc)g_free, NULL);
				g_list_free (yyvsp[-10].list);
				g_string_free (yyvsp[-1].cbuf, TRUE);
				g_string_free (yyvsp[-4].cbuf, TRUE);
				yyerror (_("parse error"));
				YYERROR;
			}

			if (yyvsp[-7].id != NULL) {
				Argument *arg = (Argument *)node;
				export_accessors (arg->name,
						  arg->get != NULL, arg->get_line,
						  arg->set != NULL, arg->set_line,
						  arg->atype,
						  arg->gtktype,
						  arg->line_no);
				g_free (yyvsp[-7].id);
			} 

						;
    break;}
case 43:
#line 873 "parse.y"
{
			Node *node = NULL;
			if(strcmp(yyvsp[-3].id, "get") == 0) {
				Type *type = pop_type();
				g_free (yyvsp[-3].id);
				node = node_new (ARGUMENT_NODE,
						 "gtktype:steal", yyvsp[-6].id,
						 "atype:steal", type,
						 "flags:steal", yyvsp[-7].list,
						 "name:steal", yyvsp[-5].id,
						 "get:steal", (yyvsp[-1].cbuf)->str,
						 "get_line", yyvsp[-2].line,
						 "line_no", yyvsp[-8].line,
						 NULL);

				g_string_free (yyvsp[-1].cbuf, FALSE);
				class_nodes = g_list_append(class_nodes, node);
			} else if(strcmp(yyvsp[-3].id, "set") == 0) {
				Type *type = pop_type();
				g_free (yyvsp[-3].id);
				node = node_new (ARGUMENT_NODE,
						 "gtktype:steal", yyvsp[-6].id,
						 "atype:steal", type,
						 "flags:steal", yyvsp[-7].list,
						 "name:steal", yyvsp[-5].id,
						 "set:steal", (yyvsp[-1].cbuf)->str,
						 "set_line", yyvsp[-2].line,
						 "line_no", yyvsp[-8].line,
						 NULL);

				g_string_free (yyvsp[-1].cbuf, FALSE);
				class_nodes = g_list_append (class_nodes, node);
			} else {
				g_free (yyvsp[-3].id); 
				g_free (yyvsp[-6].id);
				g_free (yyvsp[-5].id);
				g_list_foreach (yyvsp[-7].list, (GFunc)g_free, NULL);
				g_list_free (yyvsp[-7].list);
				g_string_free (yyvsp[-1].cbuf, TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}

			if (yyvsp[-4].id != NULL) {
				Argument *arg = (Argument *)node;
				export_accessors (arg->name,
						  arg->get != NULL, arg->get_line,
						  arg->set != NULL, arg->set_line,
						  arg->atype,
						  arg->gtktype,
						  arg->line_no);
				g_free (yyvsp[-4].id);
			} 
						;
    break;}
case 44:
#line 927 "parse.y"
{
			Node *node;
			char *get, *set = NULL;
			Variable *var;
			Type *type;
			char *root;
			
			if(strcmp(yyvsp[0].id, "link")!=0 &&
			   strcmp(yyvsp[0].id, "stringlink")!=0 && 
			   strcmp(yyvsp[0].id, "objectlink")!=0) {
				g_free(yyvsp[0].id); 
				g_free(yyvsp[-3].id);
				g_free(yyvsp[-2].id);
				g_list_foreach(yyvsp[-4].list,(GFunc)g_free,NULL);
				g_list_free(yyvsp[-4].list);
				yyerror(_("parse error"));
				YYERROR;
			}

			type = pop_type();

			var = find_var_or_die(yyvsp[-2].id, yyvsp[-5].line);
			if(var->scope == PRIVATE_SCOPE)
				root = "self->_priv";
			else if(var->scope == CLASS_SCOPE) {
				root = "SELF_GET_CLASS(self)";
				if(no_self_alias)
					error_print(GOB_ERROR, yyvsp[-5].line,
						    _("Self aliases needed when autolinking to a classwide member"));
			} else
				root = "self";

			if(strcmp(yyvsp[0].id, "link")==0) {
				set = g_strdup_printf("%s->%s = ARG;",
						      root, yyvsp[-2].id);
			} else if(strcmp(yyvsp[0].id, "stringlink")==0) {
				set = g_strdup_printf("g_free (%s->%s); "
						      "%s->%s = g_strdup (ARG);",
						      root, yyvsp[-2].id,
						      root, yyvsp[-2].id);
			} else if(strcmp(yyvsp[0].id, "objectlink")==0) {
				set = g_strdup_printf(
				  "if (ARG != NULL) "
				   "g_object_ref (G_OBJECT (ARG)); "
				  "if (%s->%s != NULL) "
				   "g_object_unref (G_OBJECT (%s->%s)); "
				  "%s->%s = ARG;",
				  root, yyvsp[-2].id,
				  root, yyvsp[-2].id,
				  root, yyvsp[-2].id);
			} else {
				g_assert_not_reached();
			}

			get = g_strdup_printf("ARG = %s->%s;", root, yyvsp[-2].id);
  
			g_free (yyvsp[0].id);

			if (type == NULL)
				type = (Type *)node_copy ((Node *)var->vtype);

			node = node_new (ARGUMENT_NODE,
					 "gtktype:steal", yyvsp[-3].id,
					 "atype:steal", type,
					 "flags:steal", yyvsp[-4].list,
					 "name:steal", yyvsp[-2].id,
					 "get:steal", get,
					 "get_line", yyvsp[-5].line,
					 "set:steal", set,
					 "set_line", yyvsp[-5].line,
					 "line_no", yyvsp[-5].line,
					 NULL);

			if (yyvsp[-1].id != NULL) {
				Argument *arg = (Argument *)node;
				export_accessors (arg->name,
						  arg->get != NULL, arg->get_line,
						  arg->set != NULL, arg->set_line,
						  arg->atype,
						  arg->gtktype,
						  arg->line_no);
				g_free (yyvsp[-1].id);
			} 

			class_nodes = g_list_append (class_nodes, node);
						;
    break;}
case 45:
#line 1015 "parse.y"
{
			if (strcmp (yyvsp[-1].id, "export")!=0) {
				g_free (yyvsp[-1].id); 
				yyerror (_("parse error"));
				YYERROR;
			}
			yyval.id = yyvsp[-1].id;
						;
    break;}
case 46:
#line 1023 "parse.y"
{
			yyval.id = NULL;
						;
    break;}
case 47:
#line 1028 "parse.y"
{
			ensure_property ();
			node_set ((Node *)property,
				  "line_no", yyvsp[-10].line,
				  "gtktype:steal", debool (yyvsp[-9].id),
				  "name:steal", yyvsp[-8].id,
				  NULL);
			if (strcmp (yyvsp[-6].id, "get") == 0 &&
			    strcmp (yyvsp[-3].id, "set") == 0) {
				node_set ((Node *)property,
					  "get:steal", (yyvsp[-4].cbuf)->str,
					  "get_line", yyvsp[-5].line,
					  "set:steal", (yyvsp[-1].cbuf)->str,
					  "set_line", yyvsp[-2].line,
					  NULL);
				g_string_free (yyvsp[-4].cbuf, FALSE);
				g_string_free (yyvsp[-1].cbuf, FALSE);
				g_free (yyvsp[-6].id); 
				g_free (yyvsp[-3].id);
			} else if (strcmp (yyvsp[-6].id, "set") == 0 &&
				   strcmp (yyvsp[-3].id, "get") == 0) {
				node_set ((Node *)property,
					  "get:steal", (yyvsp[-1].cbuf)->str,
					  "get_line", yyvsp[-2].line,
					  "set:steal", (yyvsp[-4].cbuf)->str,
					  "set_line", yyvsp[-5].line,
					  NULL);
				g_string_free (yyvsp[-4].cbuf, FALSE);
				g_string_free (yyvsp[-1].cbuf, FALSE);
				g_free (yyvsp[-6].id); 
				g_free (yyvsp[-3].id);
			} else {
				g_string_free (yyvsp[-4].cbuf, TRUE);
				g_string_free (yyvsp[-1].cbuf, TRUE);
				g_free (yyvsp[-6].id); 
				g_free (yyvsp[-3].id);
				node_free ((Node *)property);
				property = NULL;
				yyerror (_("parse error"));
				YYERROR;
			}
			property_link_and_export ((Node *)property);
			if (property != NULL) {
				class_nodes = g_list_append (class_nodes,
							     property);
				property = NULL;
			}
		;
    break;}
case 48:
#line 1076 "parse.y"
{
			ensure_property ();
			node_set ((Node *)property,
				  "line_no", yyvsp[-7].line,
				  "gtktype:steal", debool (yyvsp[-6].id),
				  "name:steal", yyvsp[-5].id,
				  NULL);
			if (strcmp (yyvsp[-3].id, "get") == 0) {
				node_set ((Node *)property,
					  "get:steal", (yyvsp[-1].cbuf)->str,
					  "get_line", yyvsp[-2].line,
					  NULL);
				g_string_free (yyvsp[-1].cbuf, FALSE);
				g_free (yyvsp[-3].id); 
			} else if (strcmp (yyvsp[-3].id, "set") == 0) {
				node_set ((Node *)property,
					  "set:steal", (yyvsp[-1].cbuf)->str,
					  "set_line", yyvsp[-2].line,
					  NULL);
				g_string_free (yyvsp[-1].cbuf, FALSE);
				g_free (yyvsp[-3].id); 
			} else {
				g_string_free (yyvsp[-1].cbuf, TRUE);
				g_free (yyvsp[-3].id); 
				node_free ((Node *)property);
				property = NULL;
				yyerror (_("parse error"));
				YYERROR;
			}
			property_link_and_export ((Node *)property);
			if (property != NULL) {
				class_nodes = g_list_append (class_nodes,
							     property);
				property = NULL;
			}
		;
    break;}
case 49:
#line 1112 "parse.y"
{
			ensure_property ();
			node_set ((Node *)property,
				  "line_no", yyvsp[-4].line,
				  "gtktype:steal", debool (yyvsp[-3].id),
				  "name:steal", yyvsp[-2].id,
				  NULL);
			property_link_and_export ((Node *)property);
			if (property != NULL) {
				class_nodes = g_list_append (class_nodes,
							     property);
				property = NULL;
			}
		;
    break;}
case 50:
#line 1128 "parse.y"
{ ; ;
    break;}
case 51:
#line 1129 "parse.y"
{ ; ;
    break;}
case 52:
#line 1132 "parse.y"
{ ; ;
    break;}
case 53:
#line 1133 "parse.y"
{ ; ;
    break;}
case 54:
#line 1136 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 55:
#line 1137 "parse.y"
{
			if (strcmp (yyvsp[-3].id, "_") != 0) {
				g_free (yyvsp[-3].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free (yyvsp[-3].id);
			yyval.id = g_strconcat ("_(", yyvsp[-1].id, ")", NULL);
			g_free (yyvsp[-1].id);
		;
    break;}
case 56:
#line 1149 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 57:
#line 1150 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 58:
#line 1153 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "nick:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 59:
#line 1159 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "blurb:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 60:
#line 1165 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "maximum:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 61:
#line 1171 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "minimum:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 62:
#line 1177 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "default_value:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 63:
#line 1183 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "flags:steal", yyvsp[0].list,
			  NULL);
		  ;
    break;}
case 64:
#line 1189 "parse.y"
{
		Type *type = pop_type ();
		ensure_property ();
		node_set ((Node *)property,
			  "ptype:steal", type,
			  NULL);
		  ;
    break;}
case 65:
#line 1196 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "extra_gtktype:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 66:
#line 1202 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "extra_gtktype:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 67:
#line 1208 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "extra_gtktype:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 68:
#line 1214 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "extra_gtktype:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 69:
#line 1220 "parse.y"
{
		ensure_property ();
		node_set ((Node *)property,
			  "extra_gtktype:steal", yyvsp[0].id,
			  NULL);
		  ;
    break;}
case 70:
#line 1226 "parse.y"
{
		ensure_property ();
		if (strcmp (yyvsp[0].id, "link") == 0) {
			g_free(yyvsp[0].id);
			node_set ((Node *)property,
				  "link", TRUE,
				  NULL);
		} else if (strcmp (yyvsp[0].id, "export") == 0) {
			g_free(yyvsp[0].id);
			node_set ((Node *)property,
				  "export", TRUE,
				  NULL);
		} else {
			g_free(yyvsp[0].id);
			yyerror(_("parse error"));
			YYERROR;
		}
		  ;
    break;}
case 71:
#line 1246 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"type")!=0) {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			yyval.id = debool (yyvsp[-4].id);
						;
    break;}
case 72:
#line 1255 "parse.y"
{
			yyval.id = debool (yyvsp[0].id);
			typestack = g_list_prepend(typestack,NULL);
						;
    break;}
case 73:
#line 1261 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 74:
#line 1262 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 75:
#line 1265 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 76:
#line 1268 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 77:
#line 1274 "parse.y"
{
			Node *node = node_new (TYPE_NODE, 
					       "name:steal", yyvsp[-1].id,
					       "pointer:steal", yyvsp[0].id,
					       NULL);
			typestack = g_list_prepend(typestack,node);
							;
    break;}
case 78:
#line 1281 "parse.y"
{
			Node *node = node_new (TYPE_NODE, 
					       "name:steal", yyvsp[0].id,
					       NULL);
			typestack = g_list_prepend(typestack,node);
							;
    break;}
case 79:
#line 1290 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 80:
#line 1293 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 81:
#line 1296 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 82:
#line 1300 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 83:
#line 1304 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 84:
#line 1308 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[-1].id, " ",
					     yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 85:
#line 1313 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-2].id, " ",
					     yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 86:
#line 1321 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 87:
#line 1325 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[-1].id);
			g_free(yyvsp[0].id);
							;
    break;}
case 88:
#line 1330 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 89:
#line 1334 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 90:
#line 1337 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 91:
#line 1341 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
							;
    break;}
case 92:
#line 1344 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
							;
    break;}
case 93:
#line 1349 "parse.y"
{ yyval.id = "void"; ;
    break;}
case 94:
#line 1350 "parse.y"
{ yyval.id = "char"; ;
    break;}
case 95:
#line 1351 "parse.y"
{ yyval.id = "short"; ;
    break;}
case 96:
#line 1352 "parse.y"
{ yyval.id = "int"; ;
    break;}
case 97:
#line 1353 "parse.y"
{ yyval.id = "long"; ;
    break;}
case 98:
#line 1354 "parse.y"
{ yyval.id = "float"; ;
    break;}
case 99:
#line 1355 "parse.y"
{ yyval.id = "double"; ;
    break;}
case 100:
#line 1356 "parse.y"
{ yyval.id = "signed"; ;
    break;}
case 101:
#line 1357 "parse.y"
{ yyval.id = "unsigned"; ;
    break;}
case 102:
#line 1360 "parse.y"
{ yyval.id = "struct"; ;
    break;}
case 103:
#line 1361 "parse.y"
{ yyval.id = "union"; ;
    break;}
case 104:
#line 1362 "parse.y"
{ yyval.id = "enum"; ;
    break;}
case 105:
#line 1365 "parse.y"
{ yyval.id = g_strdup("*"); ;
    break;}
case 106:
#line 1366 "parse.y"
{ yyval.id = g_strdup("* const"); ;
    break;}
case 107:
#line 1367 "parse.y"
{
				yyval.id = g_strconcat("*", yyvsp[0].id, NULL);
				g_free(yyvsp[0].id);
					;
    break;}
case 108:
#line 1371 "parse.y"
{
				yyval.id = g_strconcat("* const", yyvsp[0].id, NULL);
				g_free(yyvsp[0].id);
					;
    break;}
case 109:
#line 1378 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id, "last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 110:
#line 1390 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 111:
#line 1396 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 112:
#line 1408 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 113:
#line 1420 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 114:
#line 1423 "parse.y"
{
			/* the_scope was default thus public */
			the_scope = PUBLIC_SCOPE;
					;
    break;}
case 115:
#line 1429 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes, debool (yyvsp[-3].id));
						;
    break;}
case 116:
#line 1434 "parse.y"
{
			gtktypes = g_list_append(gtktypes, debool (yyvsp[0].id));
						;
    break;}
case 117:
#line 1437 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes, debool (yyvsp[0].id));
       						;
    break;}
case 118:
#line 1442 "parse.y"
{ yyval.cbuf = yyvsp[0].cbuf; ;
    break;}
case 119:
#line 1443 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 120:
#line 1447 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf,yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 121:
#line 1463 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 122:
#line 1479 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-8].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 123:
#line 1495 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 124:
#line 1511 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(PUBLIC_SCOPE, VIRTUAL_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 125:
#line 1522 "parse.y"
{
			push_function(NO_SCOPE, OVERRIDE_METHOD, yyvsp[-8].id,
				      yyvsp[-5].id, yyvsp[0].cbuf,
				      yyvsp[-10].line, ccode_line,
				      vararg, NULL);
									;
    break;}
case 126:
#line 1528 "parse.y"
{
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, REGULAR_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line, ccode_line,
				      vararg, NULL);
								;
    break;}
case 127:
#line 1538 "parse.y"
{
			if(strcmp(yyvsp[-4].id, "init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(NO_SCOPE, INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else if(strcmp(yyvsp[-4].id, "class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(NO_SCOPE, CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[0].cbuf,TRUE);
				yyerror(_("parse error "
					  "(untyped blocks must be init or "
					  "class_init)"));
				YYERROR;
			}
						;
    break;}
case 128:
#line 1561 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 129:
#line 1572 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-3].id, yyvsp[-2].id)) {
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				onerror = defreturn = NULL;
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-3].id);
			g_free(yyvsp[-1].id);
						;
    break;}
case 130:
#line 1591 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
					;
    break;}
case 131:
#line 1597 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 132:
#line 1598 "parse.y"
{
			yyval.id = (yyvsp[1].cbuf)->str;
			g_string_free(yyvsp[1].cbuf, FALSE);
					;
    break;}
case 133:
#line 1604 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 134:
#line 1605 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id, FALSE);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 135:
#line 1616 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[-1].id,"self")==0)
				push_self(yyvsp[-1].id, TRUE);
			else {
				g_free(yyvsp[-1].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 136:
#line 1627 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id, TRUE);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 137:
#line 1638 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id, FALSE);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 138:
#line 1648 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-3].id,"self")==0)
				push_self(yyvsp[-3].id, TRUE);
			else {
				g_free(yyvsp[-3].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 139:
#line 1658 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id, TRUE);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 140:
#line 1668 "parse.y"
{ has_self = FALSE; ;
    break;}
case 141:
#line 1671 "parse.y"
{ vararg = TRUE; ;
    break;}
case 142:
#line 1672 "parse.y"
{ vararg = FALSE; ;
    break;}
case 143:
#line 1675 "parse.y"
{ ; ;
    break;}
case 144:
#line 1676 "parse.y"
{ ; ;
    break;}
case 145:
#line 1679 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 146:
#line 1682 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 147:
#line 1685 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 148:
#line 1693 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 149:
#line 1703 "parse.y"
{ ; ;
    break;}
case 150:
#line 1704 "parse.y"
{ ; ;
    break;}
case 151:
#line 1707 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = node_new (CHECK_NODE,
						       "chtype", TYPE_CHECK,
						       NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = node_new (CHECK_NODE,
						       "chtype", NULL_CHECK,
						       NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 152:
#line 1724 "parse.y"
{
			Node *node = node_new (CHECK_NODE,
					       "chtype", GT_CHECK,
					       "number:steal", yyvsp[0].id,
					       NULL);
			checks = g_list_append(checks,node);
					;
    break;}
case 153:
#line 1731 "parse.y"
{
			Node *node = node_new (CHECK_NODE,
					       "chtype", LT_CHECK,
					       "number:steal", yyvsp[0].id,
					       NULL);
			checks = g_list_append(checks,node);
					;
    break;}
case 154:
#line 1738 "parse.y"
{
			Node *node = node_new (CHECK_NODE,
					       "chtype", GE_CHECK,
					       "number:steal", yyvsp[0].id,
					       NULL);
			checks = g_list_append(checks,node);
					;
    break;}
case 155:
#line 1745 "parse.y"
{
			Node *node = node_new (CHECK_NODE,
					       "chtype", LE_CHECK,
					       "number:steal", yyvsp[0].id,
					       NULL);
			checks = g_list_append(checks,node);
					;
    break;}
case 156:
#line 1752 "parse.y"
{
			Node *node = node_new (CHECK_NODE,
					       "chtype", EQ_CHECK,
					       "number:steal", yyvsp[0].id,
					       NULL);
			checks = g_list_append(checks,node);
					;
    break;}
case 157:
#line 1759 "parse.y"
{
			Node *node = node_new (CHECK_NODE,
					       "chtype", NE_CHECK,
					       "number:steal", yyvsp[0].id,
					       NULL);
			checks = g_list_append(checks,node);
					;
    break;}
case 158:
#line 1768 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 159:
#line 1769 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 160:
#line 1773 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 161:
#line 1774 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1777 "parse.y"

